VERSION 5.00
Begin VB.Form MainForm 
   Caption         =   "Folder Archiver"
   ClientHeight    =   1080
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8445
   LinkTopic       =   "Form1"
   ScaleHeight     =   1080
   ScaleWidth      =   8445
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Grabar"
      Height          =   495
      Left            =   1200
      TabIndex        =   3
      Top             =   0
      Width           =   1335
   End
   Begin VB.CommandButton selectFolderBtn 
      Caption         =   "Select Folder"
      Height          =   495
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1200
   End
   Begin VB.Label subjectLbl 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3000
      TabIndex        =   4
      Top             =   480
      Width           =   3735
   End
   Begin VB.Label folderDir 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   735
      Width           =   6735
   End
   Begin VB.Label folderName 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   3015
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
  
Const BASE_DIRECTORY As String = "D:\Datos\hp\Lista SAP"

Dim f As Outlook.MAPIFolder

Private Sub Command1_Click()
  createDirectory folderDir
  Dim Items As Outlook.Items
  Dim m As Object '
  Dim i As Integer
  'Dim m1 As Outlook.PostItem
  Dim fecha As String
  On Error Resume Next
  Set Items = f.Items
  For i = f.Items.Count To 1 Step -1
    Set m = Items(i)
  'For Each m In f.Items
    fecha = Format$(m.SentOn, "yyyy.mm.dd hh:mm")
    subjectLbl = m.Subject
    m.SaveAs folderDir & "\" & normalizaSubject(m.Subject) & " (" & fecha & ").msg", Outlook.OlSaveAsType.olMSG
    If Err = 0 Then
      DoEvents
      m.Delete
    Else
      MsgBox m.Subject, , "Error con mensaje"
      Err = 0
    End If
  Next
End Sub

Private Sub CreateFolderBtn_Click()
End Sub

Private Sub Form_Load()
  initOutlook
  
End Sub

Private Sub selectFolderBtn_Click()
  Set f = olApp.PickFolder
  folderName = f.name
  folderDir = folder2dir(BASE_DIRECTORY, f)
  DoEvents
  Me.SetFocus
End Sub

Private Function folder2dir(baseDir As String, folder As MAPIFolder) As String
  If folder.Parent.Class <> Outlook.OlObjectClass.olFolder Then
    folder2dir = baseDir & "\" & StringToFilename(folder.name)
  Else
    folder2dir = folder2dir(baseDir, folder.Parent) & "\" & StringToFilename(folder.name)
  End If
End Function

Public Function normalizaSubject(ByVal s As String)
  s = StringToFilename(s)
  s = Trim(s)
  If UCase(Left(s, 3)) = "RE " Then
    s = Mid(s, 3) & " [Re]"
  End If
  If UCase(Left(s, 3)) = "FW " Then
    s = Mid(s, 3) & " [FW]"
  End If
  s = Trim(s)
  normalizaSubject = s
End Function


